bin/sh

# sparc_sunos_5
#
#CC=/usr/local/opt/SUNWspro/bin/cc
#CFLAGS="-g -I.."
#CXX=/usr/local/opt/SUNWspro/bin/CC
#CXXFLAGS="-g -pto -I.. -DPLATFORM=sparc_sunos_5"
#AR=/usr/ccs/bin/ar
#ARFLAGS="-r"
#LEXCMD="/usr/local/bin/flex -t scan.ll > scan.cc"
#YACCCMD="/usr/local/bin/bison -d parse.yy ; mv parse.yy.tab.h parse.h ; mv parse.yy.tab.c parse.cc"
#OSLIBS=-lm

# sparc_sunos_5_gnu
#CC=/usr/local/bin/gcc
#CFLAGS="-g -I.."
#CXX=/usr/local/bin/g++
#CXXFLAGS="-g -I.."
#AR=/usr/local/bin/gar
#ARFLAGS="-r"
#LEXCMD="/usr/local/bin/flex -t scan.ll > scan.cc"
#YACCCMD="/usr/local/bin/bison -d parse.yy ; mv parse.yy.tab.h parse.h ; mv parse.yy.tab.c parse.cc"
#OSLIBS=-lm

# mips_irix_6
CC=/usr/bin/cc
CFLAGS="-g -32 -I.."
CXX=/usr/bin/CC
CXXFLAGS="-g -ptused -I.."
AR=/usr/bin/ar
ARFLAGS=-r
#LEXCMD=/usr/bin/true
#YACCCMD=/usr/bin/true
#OSLIBS=-lm

# hppa_hpux_10
CC=/usr/bin/cc
CFLAGS="-g -Ae +DAportable -I.."
CXX=/opt/aCC/bin/aCC
CXXFLAGS="-g +DAportable -I.."
AR=/usr/bin/ar
ARFLAGS=-r
LEXCMD="/usr/local/bin/flex -t scan.ll > scan.cc"
YACCCMD="/usr/local/bin/bison -d parse.yy ; mv parse.yy.tab.h parse.h ; mv parse.yy.tab.c parse.cc"
OSLIBS="-lsec -lm"


# linux_x86_2
#CC=/usr/bin/gcc
#CFLAGS="-g -I.."
#CXX=/usr/bin/g++
#CXXFLAGS="-g -I.."
#AR=/usr/bin/ar
#ARFLAGS=-r
#LEXCMD="/usr/bin/lex -t scan.ll > scan.cc"
#YACCCMD="/usr/bin/yacc -d parse.yy ; mv y.tab.h parse.h ; mv y.tab.c parse.cc"
#OSLIBS="-lm"

export CC CFLAGS CXX CXXFLAGS AR ARFLAGS

RC=0

run() {
	if [ 0 -ne $# ]
	then
		if [ -x "$1" ]
		then
			echo "$@"
			eval $@
			RC=$?
			if [ 0 -ne $RC ]
			then
				exit $RC
			fi
		fi
	fi
}

run $CC $CFLAGS -o ../osd/input.o -c ../osd/input.c
run $CC $CFLAGS -o ../osd/file.o -c ../osd/file.c
run $CC $CFLAGS -o ../osd/output.o -c ../osd/output.c
run $CC $CFLAGS -o ../osd/error.o -c ../osd/error.c
run $CC $CFLAGS -o ../osd/system.o -c ../osd/system.c
run $CC $CFLAGS -o ../osd/vsprintf.o -c ../osd/vsprintf.c
run $CC $CFLAGS -o ../osd/vsscanf.o -c ../osd/vsscanf.c
run $CC $CFLAGS -o ../osd/time.o -c ../osd/time.c
run $CC $CFLAGS -o ../osd/log.o -c ../osd/log.c
run $CXX $CXXFLAGS -o ../gpl/block.o -c ../gpl/block.cc
run $CXX $CXXFLAGS -o ../gpl/hier.o -c ../gpl/hier.cc
run $CXX $CXXFLAGS -o ../gpl/error.o -c ../gpl/error.cc
run $CXX $CXXFLAGS -o ../gpl/log.o -c ../gpl/log.cc
run $CXX $CXXFLAGS -o ../gpl/ref.o -c ../gpl/ref.cc
run $CXX $CXXFLAGS -o ../gpl/tools.o -c ../gpl/tools.cc
run $CXX $CXXFLAGS -o ../gpl/str.o -c ../gpl/str.cc
run $CXX $CXXFLAGS -o ../gpl/hash.o -c ../gpl/hash.cc
run $CXX $CXXFLAGS -o ../gpl/dlist.o -c ../gpl/dlist.cc
run $CXX $CXXFLAGS -o ../gpl/factory.o -c ../gpl/factory.cc
run $CXX $CXXFLAGS -o ../gpl/persist.o -c ../gpl/persist.cc
run $CXX $CXXFLAGS -o ../gpl/regexp.o -c ../gpl/regexp.cc
run $CXX $CXXFLAGS -o ../gpl/file.o -c ../gpl/file.cc
run $CXX $CXXFLAGS -o ../gpl/message.o -c ../gpl/message.cc
run $CXX $CXXFLAGS -o ../gpl/time.o -c ../gpl/time.cc
run $CXX $CXXFLAGS -o ../gpl/value.o -c ../gpl/value.cc
run $CXX $CXXFLAGS -o ../gpl/desc.o -c ../gpl/desc.cc
run $CXX $CXXFLAGS -o ../gpl/tuple.o -c ../gpl/tuple.cc
run $CXX $CXXFLAGS -o ../gpl/ftable.o -c ../gpl/ftable.cc
run $CXX $CXXFLAGS -o ../gpl/version.o -c ../gpl/version.cc
run $CXX $CXXFLAGS -o ../wba/argument.o -c ../wba/argument.cc
run $CXX $CXXFLAGS -o ../wba/env.o -c ../wba/env.cc
run $CXX $CXXFLAGS -o ../wba/log.o -c ../wba/log.cc
run $CXX $CXXFLAGS -o ../wba/executor.o -c ../wba/executor.cc
run $CXX $CXXFLAGS -o ../wba/app.o -c ../wba/app.cc
run $CXX $CXXFLAGS -o ../wba/lineint.o -c ../wba/lineint.cc
run $CXX $CXXFLAGS -o ../wba/shell.o -c ../wba/shell.cc

run $YACCCMD
run $LEXCMD
run $CXX $CXXFLAGS -I. -o parse.o -c parse.cc
run $CXX $CXXFLAGS -I. -o scan.o -c scan.cc
run $CXX $CXXFLAGS -o value.o -c value.cc
run $CXX $CXXFLAGS -o op.o -c op.cc
run $CXX $CXXFLAGS -o boolop.o -c boolop.cc
run $CXX $CXXFLAGS -o relop.o -c relop.cc
run $CXX $CXXFLAGS -o fnop.o -c fnop.cc
run $CXX $CXXFLAGS -o varop.o -c varop.cc
run $CXX $CXXFLAGS -o condop.o -c condop.cc
run $CXX $CXXFLAGS -o scope.o -c scope.cc
run $CXX $CXXFLAGS -o environ.o -c environ.cc
run $CXX $CXXFLAGS -o rule.o -c rule.cc
run $CXX $CXXFLAGS -o block.o -c block.cc
run $CXX $CXXFLAGS -o target.o -c target.cc
run $CXX $CXXFLAGS -o state.o -c state.cc
run $CXX $CXXFLAGS -o context.o -c context.cc
run $CXX $CXXFLAGS -o interp.o -c interp.cc
run $CXX $CXXFLAGS -o pragmaop.o -c pragmaop.cc
run $CXX $CXXFLAGS -o listop.o -c listop.cc
run $CXX $CXXFLAGS -o checkop.o -c checkop.cc
run $AR $ARFLAGS libbld.a interp.o parse.o context.o state.o target.o block.o rule.o environ.o scope.o condop.o varop.o fnop.o relop.o boolop.o op.o value.o scan.o pragmaop.o listop.o checkop.o \
../wba/shell.o ../wba/lineint.o ../wba/app.o ../wba/executor.o ../wba/log.o ../wba/argument.o ../wba/env.o \
../gpl/block.o ../gpl/version.o ../gpl/ftable.o ../gpl/tuple.o ../gpl/desc.o ../gpl/value.o ../gpl/time.o ../gpl/persist.o ../gpl/message.o ../gpl/file.o ../gpl/factory.o ../gpl/hash.o ../gpl/dlist.o ../gpl/str.o ../gpl/ref.o ../gpl/tools.o ../gpl/log.o ../gpl/hier.o ../gpl/error.o ../gpl/regexp.o \
../osd/log.o ../osd/time.o ../osd/error.o ../osd/output.o ../osd/vsscanf.o ../osd/vsprintf.o ../osd/system.o ../osd/file.o ../osd/input.o
run $CXX $CXXFLAGS -o build.o -c build.cc
run $CXX $CXXFLAGS -o build build.o libbld.a $OSLIBS

exit $RC
