#ifndef IWS_BUTTON_H
#define IWS_BUTTON_H

/******************************************************************************

Coral Tree iws/button.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/handler.h>
#include <iws/align.h>

#define IWS_SIZE_MODE_WRAP	1
#define IWS_SIZE_MODE_FILL	2

/***********************************************************************
class IWS_DefaultButtonHandler
***********************************************************************/
class IWS_DefaultButtonHandler : public IWS_Handler
{
	public:
		IWS_DefaultButtonHandler(void) {}
		virtual ~IWS_DefaultButtonHandler(void) {}

		virtual void HandleEvent(const GPL_String &string)
		{
			wbaLog("IWS WARNING", "[%s] button not handled", 
					(const char *) string);
		}		
};

/***********************************************************************
class IWS_Button
***********************************************************************/
class IWS_Button : public WDS_Button, public IWS_AnnotationAlignable
{
	public:
		IWS_Button(void);
		IWS_Button(const GPL_String & n);
		virtual ~IWS_Button(void);

		void IWS_ButtonConstructor(void);

virtual	long Operate(EW_Event *event);

		WDS_Image *GetImage(void) { return image; }

		virtual void SetEnabled(const GPL_Boolean e);
		virtual void SetSizeMode(long xsetting, long ysetting);
		virtual void SetHandler(IWS_Handler *handler, WDS_Activation *actv =
											(WDS_Activation *) GPL_BAD_ADDRESS);

		GPL_Boolean	SetImage(long index);
		GPL_Boolean	SetImage(char **i);
		GPL_Boolean	SetImageFromFile(const GPL_String & f);

virtual const char *GetText(void);
		IWS_AnnotationAlignable_DECLARATION();

		void SetAccelerator(long ascii);
	protected:
		WDS_Image *image;

	private:
static 	IWS_DefaultButtonHandler	defaultHandler;
		long						accelerator;
};

#endif /* IWS_BUTTON_H */
