/******************************************************************************

Coral Tree iws/filebtn.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/filebtn.h>

/***********************************************************************
class IWS_FileSelectorButton
***********************************************************************/
IWS_FileSelectorButton::IWS_FileSelectorButton(void)
{
	window = new IWS_FileSelectorWindow();

	// Default to blank 8+3.
	const GPL_String & fileName = window->GetFileSelector()->GetFile();
	SetName(fileName.GetData());
	SetLabel(fileName.GetData());

	showHandler = new IWS_ShowWindowHandler(window);
	SetHandler(showHandler);

	setHandler = new IWS_SetFileButtonLabelHandler();
	setHandler->SetFileSelector(window->GetFileSelector());
	setHandler->SetButton(this);
	window->SetApplyHandler(setHandler);
}

IWS_FileSelectorButton::~IWS_FileSelectorButton(void)
{
	delete showHandler;
	delete setHandler;
}

IWS_FileSelectorWindow *IWS_FileSelectorButton::GetFileSelectorWindow(void) const
{
	return window;
}

/***********************************************************************
class IWS_SetFileButtonLabelHandler
***********************************************************************/
void IWS_SetFileButtonLabelHandler::HandleEvent(const GPL_String &string)
{
	const GPL_String & fileName = GetFileSelector()->GetFile();
	button->SetName(fileName.GetData());
	button->SetLabel(fileName.GetData());
}
