#ifndef IWS_FILEBTN_H
#define IWS_FILEBTN_H

/******************************************************************************

Coral Tree iws/filebtn.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/button.h>
#include <iws/filewin.h>

/***********************************************************************
class IWS_SetFileButtonLabelHandler
***********************************************************************/
class IWS_SetFileButtonLabelHandler : public IWS_FileApplyHandler
{
	public:
		IWS_SetFileButtonLabelHandler(void)
			: button((IWS_Button *) GPL_BAD_ADDRESS) {}
		virtual ~IWS_SetFileButtonLabelHandler(void) {}

		void SetButton(IWS_Button *b) { button = b; }

		virtual void HandleEvent(const GPL_String & string);

	protected:
		IWS_Button *button;
};

/***********************************************************************
class IWS_FileSelectorButton
***********************************************************************/
class IWS_FileSelectorButton : public IWS_Button
{
	public:
		IWS_FileSelectorButton(void);
		virtual ~IWS_FileSelectorButton(void);

		IWS_FileSelectorWindow *GetFileSelectorWindow(void) const;

	protected:
		IWS_FileSelectorWindow *window;
		IWS_ShowWindowHandler *showHandler;
		IWS_SetFileButtonLabelHandler *setHandler;
};

#endif /* IWS_FILEBTN_H */
