/******************************************************************************

Coral Tree iws/lookbtn.cc
Copyright (C) 1999 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <iws/iws.h>

#include <iws/xpm/athena.xpm>
#include <iws/xpm/hybrid.xpm>
#include <iws/xpm/motif.xpm>
#include <iws/xpm/simple.xpm>
#include <iws/xpm/win32.xpm>

void IWS_LookChangeHandler::HandleEvent(const GPL_String &string)
{
	fprintf(stdout,"[%s]\n",(const char *)string);
	IWS_LookButton *lookbutton;
	lookbutton = (IWS_LookButton *)(GetActivation()->GetTargetWidget());
	lookbutton->NextLook();
}

IWS_LookButton::IWS_LookButton(void)
{
	namelist.Append("athena");
	namelist.Append("hybrid");
	namelist.Append("motif");
	namelist.Append("simple");
	namelist.Append("win32");
	currentName = 0;
	SetName(namelist[currentName]);
	SetLabel(namelist[currentName]);

	SetHandler(&lookHandler);
}

IWS_LookButton::~IWS_LookButton(void)
{
}

void IWS_LookButton::NextLook(void)
{
	currentName++;
	if(currentName >= namelist.GetCount()) { currentName = 0; }
	SetName(namelist[currentName]);
	SetLabel(namelist[currentName]);
	if(namelist[currentName] == "athena") { SetImage(iwsAthenaXPM); }
	if(namelist[currentName] == "hybrid") { SetImage(iwsHybridXPM); }
	if(namelist[currentName] == "motif") { SetImage(iwsMotifXPM); }
	if(namelist[currentName] == "simple") { SetImage(iwsSimpleXPM); }
	if(namelist[currentName] == "win32") { SetImage(iwsWin32XPM); }
	GetLooks()->LoadFromFile(namelist[currentName]);
	EW_EventContext *context=GetRootWindow()->GetEventContext();
	EW_WindowList *windowlist=context->GetWindowList();
	EW_Window *node;
	windowlist->ToHead();
	while( (node=windowlist->PostIncrement()) != NULL)
	{
		// propagate relevant changes to all windows
		GetLooks()->ResetWindow((EW_Window *)node);
		node->SetDirty(EW_DIRTY_COMPLETE);
	}

	GetRootWindow()->RingBell();
}






