#ifndef IWS_STATBTN_H
#define IWS_STATBTN_H

/******************************************************************************

Coral Tree iws/statbtn.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <wds/wds.h>
#include <iws/window.h>
#include <iws/getstr.h>
#include <iws/btnbar.h>

class IWS_StatusButton;

/******************************************************************************
class IWS_StatusViewerDelivery
******************************************************************************/
class IWS_StatusButtonDelivery : public GPL_Delivery
{
	private:
		IWS_StatusButton *statusButton;
	public:
		IWS_StatusButtonDelivery(IWS_StatusButton *sb)
			{ statusButton = sb; }
virtual	~IWS_StatusButtonDelivery(){}
virtual	GPL_Boolean Deliver(	const GPL_String & filename,
								const long linenum,
								const GPL_String & tname,
								const GPL_String & text);
		
};


/***********************************************************************
class IWS_StatusViewerWindow
***********************************************************************/
class IWS_StatusViewerWindow : public IWS_VerticalWindow
{
	public:
		IWS_StatusViewerWindow(void);
		virtual ~IWS_StatusViewerWindow(void);

		virtual void SetStata(const GPL_List<GPL_String> & s);
		IWS_StringList *GetStata(void){ return stata; }

	protected:
		IWS_StringList *stata;
		IWS_HideWindowHandler *hideHandler;
		IWS_ButtonBar *buttonBar;
};

/***********************************************************************
class IWS_StatusButton
***********************************************************************/
class IWS_StatusButton : public IWS_Button
{
	public:
		IWS_StatusButton(void);
		virtual ~IWS_StatusButton(void);

		unsigned long GetHistory(void) const { return history; }
		const GPL_List<GPL_String> & GetStata(void) const { return stata; }

		void SetHistory(const unsigned long h) { history = GPL_MINIMUM(1, h); }
		virtual void SetStatus(const GPL_String & s);

		void AttachLogger(void);

	protected:
		unsigned long history;
		GPL_List<GPL_String> stata;
		IWS_StatusViewerWindow *window;
		IWS_Handler *handler;
		GPL_Boolean attachedToLogger;
};

/***********************************************************************
class IWS_ShowStatusViewerWindowHandler
***********************************************************************/
class IWS_ShowStatusViewerWindowHandler : public IWS_ShowWindowHandler
{
	public:
		IWS_ShowStatusViewerWindowHandler(IWS_StatusButton *b,
											IWS_StatusViewerWindow *w)
		: IWS_ShowWindowHandler((IWS_Window *) w), button(b), window(w) {}
		virtual ~IWS_ShowStatusViewerWindowHandler(void) {}

		virtual void HandleEvent(const GPL_String &string);

	protected:
		IWS_StatusButton *button;
		IWS_StatusViewerWindow *window;
};

#endif /* IWS_STATBTN_H */
