#!/bin/sh

USAGE="Usage: $0 [-d directory] [-h] [-m module] [-p package] [-s section] files..."
DATE=`date +%Y-%m-%d`
DIRECTORY=.
MODULE="User Commands"
PACKAGE="XXX"
SECTION="1"

while getopts \?d:hm:p:s: OPT
do
	case $OPT in
	d)		DIRECTORY=$OPTARG ;;
	m)		MODULE=$OPTARG ;;
	p)		PACKAGE=$OPTARG ;;
	s)		SECTION=$OPTARG ;;
	h | \?)	echo $USAGE
			exit 1 ;;
	esac
done
shift `expr $OPTIND - 1`

OLD_DIR=`pwd`

while [ 0 -ne $# ]
do
	cd `dirname $1`
	DESTINATION=$DIRECTORY
	if [ "$DESTINATION" != "." ]
	then
		DESTINATION=${DIRECTORY}/man${SECTION}/`basename $1 .pod`.${SECTION}
	else
		DESTINATION=`basename $1 .pod`.${SECTION}
	fi
	echo "pod2man --release=$DATE --date=$PACKAGE --center=$MODULE --section=$SECTION `basename $1` > $DESTINATION"
	pod2man "--release=$DATE" "--date=$PACKAGE" \
		"--center=$MODULE" "--section=$SECTION" `basename $1` \
		> "$DESTINATION"
	shift
done

cd $OLD_DIR

