/******************************************************************************

Coral Tree spa/blenc.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <osd/osd.h>
#include <spa/spa.h>

static GPL_Byte slist[256] =
{
	243, 166, 253, 209, 132, 193, 185, 164,
	150, 234, 242, 240, 247, 229, 244, 134,
	129, 233, 207, 168, 218, 159, 206, 200,
	192, 222, 239, 183, 226, 236, 255, 204,
	144, 219, 137, 245, 196, 230, 175, 250,
	221, 180, 213, 249, 202, 146, 208, 167,
	227, 140, 171, 136, 169, 160, 151, 154,
	216, 181, 248, 188, 198, 158, 203, 194,
	201, 246, 205, 174, 191, 170, 163, 153,
	231, 165, 190, 141, 187, 211, 156, 210,
	214, 184, 235, 186, 162, 161, 189, 157,
	251, 232, 148, 155, 139, 128, 135, 238,
	225, 212, 228, 178, 199, 224, 215, 138,
	254, 130, 182, 223, 179, 217, 252, 237,
	241, 149, 142, 173, 176, 147, 133, 131,
	143, 177, 172, 195, 197, 152, 145, 220,
	93, 16, 105, 119, 4, 118, 15, 94,
	51, 34, 103, 92, 49, 75, 114, 120,
	32, 126, 45, 117, 90, 113, 8, 54,
	125, 71, 55, 91, 78, 87, 61, 21,
	53, 85, 84, 70, 7, 73, 1, 47,
	19, 52, 69, 50, 122, 115, 67, 38,
	116, 121, 99, 108, 41, 57, 106, 27,
	81, 6, 83, 76, 59, 86, 74, 68,
	24, 5, 63, 123, 36, 124, 60, 100,
	23, 64, 44, 62, 31, 66, 22, 18,
	46, 3, 79, 77, 97, 42, 80, 102,
	56, 109, 20, 33, 127, 40, 25, 107,
	101, 96, 28, 48, 98, 13, 37, 72,
	89, 17, 9, 82, 29, 111, 95, 26,
	11, 112, 10, 0, 14, 35, 65, 12,
	58, 43, 39, 88, 110, 2, 104, 30,
};

#define	SPA_OFF	(0 == key.GetCount() ? 0 : key[i % key.GetCount()])

/******************************************************************************
SPA_BlockEncrypter
******************************************************************************/
/******************************************************************************
SPA_BlockEncrypter::SPA_BlockEncrypter(void)
******************************************************************************/
SPA_BlockEncrypter::SPA_BlockEncrypter(void)
{
}

/******************************************************************************
SPA_BlockEncrypter::~SPA_BlockEncrypter(void)
******************************************************************************/
SPA_BlockEncrypter::~SPA_BlockEncrypter(void)
{
}

/******************************************************************************
GPL_Boolean SPA_BlockEncrypter::Encrypt(const GPL_Block & key, GPL_Block & data)
******************************************************************************/
GPL_Boolean SPA_BlockEncrypter::Encrypt(const GPL_Block & key, GPL_Block & data)
{
	const unsigned long n = data.GetSize();
	for (unsigned long i = 0; n > i; ++i)
	{
		data[i] = 0xFF & (slist[data[i]] + SPA_OFF);
	}
	return TRUE;
}

/******************************************************************************
GPL_Boolean SPA_BlockEncrypter::Decrypt(const GPL_Block & key, GPL_Block & data)
******************************************************************************/
GPL_Boolean SPA_BlockEncrypter::Decrypt(const GPL_Block & key, GPL_Block & data)
{
	const unsigned long n = data.GetSize();
	for (unsigned long i = 0; n > i; ++i)
	{
		data[i] = slist[(256 + data[i] - SPA_OFF) % 256];
	}
	return TRUE;
}

GPL_OBJECT_IMPLEMENTATION(SPA_BlockEncrypter, 0x40020000, "SPA_BlockEncrypter");
