#ifndef DNA_MESSAGE_H
#define DNA_MESSAGE_H

/******************************************************************************

Coral Tree dna/message.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <dna/bus.h>

/***********************************************************************
class DNA_Message

Network message.
***********************************************************************/
class DNA_Message : public GPL_Message
{
	public:
		DNA_Message(void);
		DNA_Message(const DNA_Message & msg);
		virtual ~DNA_Message(void);

		DNA_Message & operator=(const DNA_Message & msg);

		// DNA_Bus-based
		virtual GPL_Boolean Send(DNA_Bus *bus);
		virtual GPL_Boolean Receive(DNA_Bus *bus, const long timeout);
		virtual GPL_Boolean Receive(DNA_Bus *bus) { return Receive(bus, 0); }
};

#endif /* DNA_MESSAGE_H */
